package generated.A0000001M;

/**
 * Local skeleton for org.objectweb.dsrg.sofa.demos.sofashop.db.storage.ObjectStorage.
 *
 * A skeleton element has a server remote port "line" through which
 * remote clients connect to the target object, which is bound to
 * the "call" required port.
 *
 */
public final class LocalSkeleton
    implements
        org.objectweb.dsrg.connector.ElementRemoteServer,
        org.objectweb.dsrg.connector.ElementLocalClient,
        org.objectweb.dsrg.connector.ReconfigurableElement,
        org.objectweb.dsrg.sofa.demos.sofashop.db.storage.ObjectStorage {

    /**
     * Local target of business method invocations.
     */
    protected org.objectweb.dsrg.sofa.demos.sofashop.db.storage.ObjectStorage target;

    /**
     * Instance of dock connector manager which is responsible for connector
     * units within the dock.
     */
    protected final org.objectweb.dsrg.connector.mgr.DockConnectorManager dcm;

    /**
     * Reference to parent connector unit.
     */
    protected final org.objectweb.dsrg.connector.ConnectorUnit parentUnit;

    protected boolean isTopLevel;

    /**
     * Reconfiguration request handler.
     */
    protected org.objectweb.dsrg.connector.ReconfigurationHandler reconfigurationHandler;


    /* **********************************************************************
     * CONSTRUCTORS
     * **********************************************************************/

    /**
     * Creates a new local skeleton element.
     */
    public LocalSkeleton (
            org.objectweb.dsrg.connector.ConnectorUnit parentUnit,
            boolean isTopLevel) {

        this.parentUnit = parentUnit;
        this.isTopLevel = isTopLevel;

        dcm = org.objectweb.dsrg.connector.mgr.
            DockConnectorManagerHelper.getDockConnectorManager ();
    }


    /* **********************************************************************
     * Element Methods
     * **********************************************************************/

	public final String getElementInfo (String indent) {
		StringBuilder result = new StringBuilder ();

		result.append (indent +"Implementation: \"orig_local_skeleton\"\n");

		return result.toString ();
	}


    /**
     * Sets the reconfiguration handler.
     */
    public final void setElReconfigurationHandler (
        org.objectweb.dsrg.connector.ReconfigurationHandler reconfigurationHandler) {

        this.reconfigurationHandler = reconfigurationHandler;
    }


    /* **********************************************************************
     * ElementLocalClient Methods
     * **********************************************************************/

    /**
     * Binds a given required port of this element to a target object using
     * a local object reference.
     *
     * TODO: Handle reconfiguration.
     */
    public void bindElPort (String portName, Object target)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("call".equals (portName)) {
            this.target = (org.objectweb.dsrg.sofa.demos.sofashop.db.storage.ObjectStorage) target;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to bind non-existent required port '"+ portName +"'.");
        }
    }


    /**
     * Unbinds a given required port of this element from its target.
     *
     * TODO: Handle reconfiguration.
     */
    public void unbindElPort (String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        if ("call".equals (portName)) {
            this.target = null;

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to unbind non-existent required port '"+ portName +"'.");
        }
    }


    /* **********************************************************************
     * ElementRemoteServer Methods
     * **********************************************************************/

    /**
     * Provides a bundle of remote references to the given remote server port.
     * Since this is a local skeleton, "local" reference is returned in the
     * reference bundle.
     */
    public org.objectweb.dsrg.connector.RemoteRefBundle lookupElRemotePort (
            String portName)
        throws org.objectweb.dsrg.connector.ElementLinkException {

        org.objectweb.dsrg.connector.RemoteRefBundle result =
            new org.objectweb.dsrg.connector.RemoteRefBundle ();

        if ("line".equals (portName)) {
            Object portReference;

            if (target == null) {
                /*
                 * If the element is not yet bound to the target object,
                 * return a reference to itself. This will cause all
                 * invocations of target object methods to pass through
                 * this element, where they can be delayed.
                 */
                portReference = this;

            } else {
                portReference = target;
            }

            result.addRef (
                new org.objectweb.dsrg.connector.RemoteRef (
                    "local",
                    org.objectweb.dsrg.connector.
                        LocalReferenceRegistry.stringify (portReference)
                )
            );

        } else {
            throw new org.objectweb.dsrg.connector.ElementLinkException (
                "Attempt to look up non-existent remote port '"+ portName +"'.");
        }

        return result;
    }


    /**
     * Returns the names of remote ports supported by this element.
     */
    public String [] listElRemotePorts () {
        return new String [] { "line" };
    }


    /* **********************************************************************
     * org.objectweb.dsrg.sofa.demos.sofashop.db.storage.ObjectStorage Methods
     * **********************************************************************/

	public int open (boolean arg0) {
		int result;
		result = this.target.open (arg0);
		return result;
	}

	public org.objectweb.dsrg.sofa.demos.sofashop.db.storage.QueryResult fetchObjects (int arg0, org.neodatis.odb.core.query.IQuery arg1, int arg2, int arg3) {
		org.objectweb.dsrg.sofa.demos.sofashop.db.storage.QueryResult result;
		result = this.target.fetchObjects (arg0, arg1, arg2, arg3);
		return result;
	}

	public void disconnectObjects (int arg0, java.util.Set arg1) {
this.target.disconnectObjects (arg0, arg1);
		return;
	}

	public org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.AbstractBase storeObject (int arg0, org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.AbstractBase arg1) {
		org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.AbstractBase result;
		result = this.target.storeObject (arg0, arg1);
		return result;
	}

	public void commitAndClose (int arg0) {
this.target.commitAndClose (arg0);
		return;
	}

	public void rollbackAndClose (int arg0) {
this.target.rollbackAndClose (arg0);
		return;
	}


}
