package org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui;

/** Payment refused exception.
    * 
    * <p>
    * Here are logical causes of the exception:
    * <ul>
    * <li>{@link #paymentStarted} called out of standard sale process</li>
    * <li>card validation failed</li>
    * <li>card does not support <i>cash back</i> mode</li>
    * </ul>
    * </p>
    */
  public class PaymentRefusedException extends Exception {
	 /** Generated serial version UID. */
	private static final long serialVersionUID = 4305471576630434270L;
	/** Default constructor. */
	public PaymentRefusedException () {
      super();
    }
	/** Constructor.
	  *
	  * @param message
	  */
    public PaymentRefusedException(String message) {
      super(message);
    }
	/** Constructor.
	  *
	  * @param message
	  * @param cause
	  */    
    public PaymentRefusedException(String message, Throwable cause) {
      super(message, cause);
    }
	/** Constructor.
	  *
	  * @param message
	  * @param cause
	  */    
    public PaymentRefusedException(Throwable cause) {
      super(cause);
    }
  }