/* $Id: SwingInitializer.java 813 2009-11-17 12:05:05Z ondrac $
 *
 * SofaShop demo for SOFA 2.0 component system
 * Copyright (C) 2009  DSRG, Charles University in Prague
 *                     http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui;

import org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui.swing.MainFrame;

public class SwingInitializer implements Runnable {

	private volatile MainFrame mainFrame;
	
	public SwingInitializer() {
		this.mainFrame = null;
	}

	/** Starts or stops GUI.
	  *
	  * <p>Odd (1st, 3rd, ...) executions start the GUI.</p>
	  * <p>Even (2nd, 4th, ...) executions stops the GUI.</p> 
	  * 
	  */
	@Override
	public void run() {
		if (mainFrame == null) {
			mainFrame = new MainFrame();
			mainFrame.setVisible(true);
		} else {
			mainFrame.dispose();
		}
	}
	
	/**
	  * 
	  * @return MainFrame or <code>null</code> if not initialized yet.
	  */
	public MainFrame getMainFrame() {
		return mainFrame;
	}
	
	public boolean isActive() {
		return (mainFrame != null);
	}
}
