package org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui.swing;

import java.awt.Component;
import javax.swing.Icon;

public class ModeTabs extends SwitchableTabbedPane {
	
	public enum Mode {
		CASH_PAYMENT(2, 0), CARD_PAYMENT(2, 1), SALE(1, 0), START(0, 0);
		
		private int level1Value;
		private int level2Value;
		private Mode(int value1, int value2) {
			this.level1Value = value1;
			this.level2Value = value2;
		}
		public int getIndex() {
			return level1Value;
		}
		public int getSubCompIndex() {
			return level2Value;
		}
	}
		

	private static final long serialVersionUID = 1L;

	public static final int TAB_INTERNAL_COMPONENT_WIDTH = 600;
	public static final int TAB_INTERNAL_COMOPNENT_HEIGHT = 800;
	public static final int INTERNAL_COMPONENT_WIDTH = TAB_INTERNAL_COMPONENT_WIDTH + 20;
	public static final int INTERNAL_COMOPNENT_HEIGHT = TAB_INTERNAL_COMOPNENT_HEIGHT + 20;
	public static final int COMPNENT_WITDH = INTERNAL_COMPONENT_WIDTH + 20;
	public static final int COMPNENT_HEIGHT = INTERNAL_COMPONENT_WIDTH + 20;
	
	
	private PaymentPane paymentPane = null;
	private SalePane salePane = null;
	private StartPane startPane = null;

	/**
	 * This is the default constructor
	 */
	public ModeTabs() {
		super();
		initialize();
		addModeTab("Start", null, getStartPane());
		addModeTab("Sale", null, getSalePane());
		addModeTab("Payment", null, getPaymentPane());
		setMode(Mode.START);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(COMPNENT_WITDH, COMPNENT_HEIGHT);
	}
	
	private void addModeTab(String name, Icon i, Component content) {
		this.addTab(name, i,content);
		this.setEnabledAt(this.getTabCount() - 1, false);
	}
	
	public StartPane getStartPane() {
		if (startPane == null) {
			startPane = new StartPane();
		}
		return startPane;	
	}
	
	public SalePane getSalePane() {
		if (salePane == null) {
			salePane = new SalePane();
		}
		return salePane;	
	}
	
	public PaymentPane getPaymentPane() {
		if (paymentPane == null) {
			paymentPane = new PaymentPane();
		}
		return paymentPane;
	}
	
	public void setMode(Mode m) {
		Component c = this.getComponentAt(m.getIndex());
		if (c instanceof ModePane) {
			ModePane mp = (ModePane)c;
			mp.selectThis(m.getIndex(), getSelectedIndex() , m.getSubCompIndex());
		} else {
			System.err.printf("Error: ModeTabs: unable to access tab %d as ModePane (it is %s).\n", m.getIndex(), c == null ? "<null>" : c.getClass());
		}
		switchTab(m.getIndex());
	}
	
}
