package org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui.swing;

import java.awt.Color;
import java.awt.Container;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;

import org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui.ControllerHelper;
import org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui.swing.ModeTabs.Mode;

public class SalePane extends JPanel implements ActionListener, ModePane {

	private static final long serialVersionUID = 1L;

	private static final int ROOT_GRIDX = 0;
	private static final int SALE_LABEL_ROW_START_GRIDX = ROOT_GRIDX;
	private static final int SALE_LABEL_ROW_START_GRIDY = 0;
	private static final int SALE_INPUT_ROW_START_GRIDX = ROOT_GRIDX;
	private static final int SALE_INPUT_ROW_START_GRIDY = SALE_LABEL_ROW_START_GRIDY + 1;
	private static final int SALE_TABLELABEL_ROW_START_GRIDX = ROOT_GRIDX;
	private static final int SALE_TABLELABEL_ROW_START_GRIDY = SALE_INPUT_ROW_START_GRIDY + 1; 
	private static final int SALE_TABLE_ROW_START_GRIDX = ROOT_GRIDX;
	private static final int SALE_TABLE_ROW_START_GRIDY = SALE_TABLELABEL_ROW_START_GRIDY + 1;
	private static final int SALE_TABLECTRL_ROW_START_GRIDX = ROOT_GRIDX;
	private static final int SALE_TABLECTRL_ROW_START_GRIDY = SALE_TABLE_ROW_START_GRIDY + 1;
	private static final int SALE_SALECTRLLABEL_ROW_START_GRIDX = ROOT_GRIDX;
	private static final int SALE_SALECTRLLABEL_ROW_START_GRIDY = SALE_TABLECTRL_ROW_START_GRIDY + 1;
	private static final int SALE_SALECTRL_ROW_START_GRIDX = ROOT_GRIDX;
	private static final int SALE_SALECTRL_ROW_START_GRIDY = SALE_SALECTRLLABEL_ROW_START_GRIDY + 1;
		
	
	private static final int SALE_AMOUNT_IPADX = 30;
	private static final int SALE_EAN_IPADX = 120;
	
	private static final String DEFAULT_EAN_TEXT = "";
	private static final String DEFAULT_AMOUNT_TEXT = "1";
	private static final String DEFAULT_VALIDATION_MESSAGE = "";
	private static final String DEFAULT_TOTAL_LABEL_PREFIX_TEXT = "Total: ";
	

	
	
	/** JTextField for sale item amount input. */
	private JTextField amountInput = null;
	/** JTextField for sale item EAN input. */
	private JTextField EANInput = null;
	/** JButton OK. */
	private JButton okButton = null;
	/** JLable for input validation messages. */
	private JLabel validationLabel = null;
	/** Sale table model. */
	private SaleTableModel saleTableModel = null;
	/** JTable of sale items. */
	private JTable saleTable = null;
	/** JScrollPane for sale table. */
	private JScrollPane saleTableScrollPane = null;
	/** JButton for deleting sale item. */
	private JButton saleItemDeleteButton = null;
	/** JButton for starting cash payment. */
	private JButton startCashPaymentButton = null;
	/** JButton for starting card payment. */
	private JButton startCardPaymentButton = null;
	/** JButton for canceling sale. */
	private JButton cancelSaleButton = null;
	/** JLabel showing total. */
	private JLabel totalLabel = null;

	/**
	 * This is the default constructor
	 */
	public SalePane() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new GridBagLayout());
		this.setSize(ModeTabs.INTERNAL_COMPONENT_WIDTH, ModeTabs.INTERNAL_COMPONENT_WIDTH);
		placeAmountInput();
		placeEANInput();
		placeOkButton();
		placeValidationLabel();
		placeAmountLabel();
		placeEANLabel();
		placeSaleTableLabel();
		placeSaleTable();
		placeDeleteSaleItemButton();
		placeTotalLabel();
		placeStartCashPaymentButton();
		placeStartCardPaymentButton();
		placeCancelSaleItemButton();
		
	}
	
	/**
	 * 
	 */
	private void placeAmountInput() {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_INPUT_ROW_START_GRIDX;
		c.gridy = SALE_INPUT_ROW_START_GRIDY;
		c.ipadx = SALE_AMOUNT_IPADX;
		c.anchor = GridBagConstraints.WEST;		
		this.add(getAmountInput(), c);
	}
	
	/**
	 * 
	 */
	private void placeEANInput() {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_INPUT_ROW_START_GRIDX + 1;
		c.gridy = SALE_INPUT_ROW_START_GRIDY;
		c.ipadx = SALE_EAN_IPADX;
		c.anchor = GridBagConstraints.WEST;		
		this.add(getEANInput(), c);
	}

	/**
	 * 
	 */
	private void placeOkButton() {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_INPUT_ROW_START_GRIDX + 2;
		c.gridy = SALE_INPUT_ROW_START_GRIDY;
		c.anchor = GridBagConstraints.WEST;				
		this.add(getOkButton(), c);
	}
	
	/**
	 * 
	 */
	private void placeValidationLabel() {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_INPUT_ROW_START_GRIDX + 3;
		c.gridy = SALE_INPUT_ROW_START_GRIDY;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.CENTER;
		this.add(getValidationLabel(), c);
	}

	/**
	 * 
	 */
	private void placeAmountLabel() {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_LABEL_ROW_START_GRIDX;
		c.gridy = SALE_LABEL_ROW_START_GRIDY;
		c.ipadx = SALE_AMOUNT_IPADX;
		c.anchor = GridBagConstraints.WEST;
		this.add(new JLabel("Amount:"), c);
	}
	
	/**
	 * 
	 */
	private void placeEANLabel() {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_LABEL_ROW_START_GRIDX + 1;
		c.gridy = SALE_LABEL_ROW_START_GRIDY;
		c.ipadx = SALE_EAN_IPADX;
		c.anchor = GridBagConstraints.WEST;
		this.add(new JLabel("EAN:"), c);
	}

	/**
	 * 
	 */
	private void placeSaleTableLabel() {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_TABLELABEL_ROW_START_GRIDX;
		c.gridy = SALE_TABLELABEL_ROW_START_GRIDY;
		c.anchor = GridBagConstraints.WEST;
		c.gridwidth = GridBagConstraints.REMAINDER;
		JLabel saleTableLabel = new JLabel("Sale overview:");
		this.add(saleTableLabel, c);
	}
	
	/**
	 * 
	 */
	private void placeSaleTable() {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_TABLE_ROW_START_GRIDX;
		c.gridy = SALE_TABLE_ROW_START_GRIDY;
		c.anchor = GridBagConstraints.WEST;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.ipadx = ModeTabs.TAB_INTERNAL_COMPONENT_WIDTH;
		c.ipady = ModeTabs.TAB_INTERNAL_COMOPNENT_HEIGHT / 2;
		JTable table = getSaleTable();
	    JScrollPane scrollPane = getSaleTableScrollPane();
	    scrollPane.setViewportView(table);
	    scrollPane.setSize(c.ipadx, c.ipady);
	    table.setFillsViewportHeight(true);
		this.add(scrollPane, c);
	}
	
	private void placeDeleteSaleItemButton() {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_TABLECTRL_ROW_START_GRIDX;
		c.gridy = SALE_TABLECTRL_ROW_START_GRIDY;
		c.anchor = GridBagConstraints.WEST;
		c.insets = new Insets(0, 0, 20, 0);
		JButton b = getSaleItemDeleteButton();
		b.setEnabled(false);
		this.add(b, c);
	}

	private void placeTotalLabel() {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_TABLECTRL_ROW_START_GRIDX + 1;
		c.gridy = SALE_TABLECTRL_ROW_START_GRIDY;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.EAST;
		c.insets = new Insets(0, 0, 20, 0);
		JLabel l = getTotalLabel();
		setTotalValue(0);
		this.add(l, c);
	}

	
	private void placeStartCashPaymentButton () {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_SALECTRL_ROW_START_GRIDX;
		c.gridy = SALE_SALECTRL_ROW_START_GRIDY;
		c.anchor = GridBagConstraints.WEST;
		c.insets = new Insets(0, 0, 0, 20);
		this.add(getStartCashPaymentButton(), c);		
	}
	
	private void placeStartCardPaymentButton () {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_SALECTRL_ROW_START_GRIDX + 1;
		c.gridy = SALE_SALECTRL_ROW_START_GRIDY;
		c.anchor = GridBagConstraints.WEST;		
		this.add(getStartCardPaymentButton(), c);		
	}
	
	private void placeCancelSaleItemButton() {
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = SALE_SALECTRL_ROW_START_GRIDX + 2;
		c.gridy = SALE_SALECTRL_ROW_START_GRIDY;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.EAST;				
		this.add(getCancelSaleButton(), c);		
	}

	

	/**
	 * 
	 */
	public JTextField getAmountInput() {
		if (amountInput == null) {
			amountInput = new JTextField();
			amountInput.setText(DEFAULT_AMOUNT_TEXT);
		}
		return amountInput;
	}
	
	/**
	 * 
	 */
	public JTextField getEANInput() {
		if (EANInput == null) {
			EANInput = new JTextField();
			EANInput.setText(DEFAULT_EAN_TEXT);
			EANInput.addActionListener(this);
		}
		return EANInput;
	}
	
	/**
	 * 
	 */
	public JButton getOkButton() {
		if (okButton == null) {
			okButton = new JButton("OK");
			okButton.addActionListener(
					new SalePaneSaleAddedListener(this));
		}
		return okButton;
	}
	
	/**
	 * 
	 */
	public JLabel getValidationLabel() {
		if (validationLabel == null) {
			validationLabel = new JLabel(DEFAULT_VALIDATION_MESSAGE);
			validationLabel.setForeground(Color.RED);
		}
		return validationLabel;
	}
	 
	/**
	 * 
	 */
	public SaleTableModel getSaleTableModel() {
		if (saleTableModel == null) {
			saleTableModel = new SaleTableModel();
		}
		return saleTableModel;
	}
	
	/**
	 *
	 */
	public JTable getSaleTable() {
		if (saleTable == null) {
			saleTable = new JTable(getSaleTableModel());			
		}
		return saleTable;
	}
	/**
	 *
	 */
	public JScrollPane getSaleTableScrollPane() {
		if (saleTableScrollPane == null) {
			saleTableScrollPane = new JScrollPane();
		}
		return saleTableScrollPane;
	}
	
	public JButton getSaleItemDeleteButton() {
		if (saleItemDeleteButton == null) {
			saleItemDeleteButton = new JButton("Delete");
			saleItemDeleteButton.addActionListener(this);
		}
		return saleItemDeleteButton;
	}
	
	public JButton getStartCashPaymentButton() {
		if (startCashPaymentButton == null) {
			startCashPaymentButton = new JButton("Cash payemnt");
			startCashPaymentButton.addActionListener(this);
		}
		return startCashPaymentButton;
	}
	
	public JButton getStartCardPaymentButton() {
		if (startCardPaymentButton == null) {
			startCardPaymentButton = new JButton("Card payment");
			startCardPaymentButton.addActionListener(this);
		}
		return startCardPaymentButton;
	}
	
	public JButton getCancelSaleButton() {
		if (cancelSaleButton == null) {
			cancelSaleButton = new JButton("Cancel");
			cancelSaleButton.addActionListener(this);
		}
		return cancelSaleButton;
	}
	
	public JLabel getTotalLabel() {
		if (totalLabel == null) {
			totalLabel = new JLabel(DEFAULT_TOTAL_LABEL_PREFIX_TEXT);
			totalLabel.setFont(totalLabel.getFont().deriveFont(Font.BOLD));
		}
		return totalLabel;
	}
	
	
	
	/**
	 * 
	 */
	public void controlsSetEnabled(boolean enabled) {
		getOkButton().setEnabled(enabled);
		getEANInput().setEnabled(enabled);
		getAmountInput().setEnabled(enabled);
		//getSaleItemDeleteButton().setEnabled(enabled);
		getStartCardPaymentButton().setEnabled(enabled && !getSaleTableModel().isDataEmpty());
		getStartCashPaymentButton().setEnabled(enabled && !getSaleTableModel().isDataEmpty());
	}
	
	/**
	 * 
	 */
	public void scrollSaleTableDown() {
		JScrollBar jsb = getSaleTableScrollPane().getVerticalScrollBar();
		if (jsb != null) {
			int newVal = jsb.getMaximum();
			jsb.setValue(newVal);
		}	
	}
		
	/**
	 * 
	 */
	public String getCurrentEAN() {
		return getEANInput().getText();
	}
	/**
	  *
	  * @return
	  * @throws Exception
	  */
	private double getCurrentAmountErrorProne()
	throws Exception {
		String text = getAmountInput().getText();
		return Double.valueOf(text);
	}
	/**
	  * 
	  */
	public double getCurrentAmount() {
		double result = 0;
		try {
			result = getCurrentAmountErrorProne();
		} catch (Exception e) {
		}
		return result;
	}
	
	/**
	  * 
	  */
	public void resetInputs() {
		getEANInput().setText(DEFAULT_EAN_TEXT);
		getAmountInput().setText(DEFAULT_AMOUNT_TEXT);
		showValidationMessage(DEFAULT_VALIDATION_MESSAGE);
	}
	
	/**
	  *
	  */
	public void showValidationMessage(String m) {
		if (m != null) {
			getValidationLabel().setText(m);
		}
	}
	
	private ModeTabs getModeTabs() {
		Container c = getParent();
		if (c instanceof ModeTabs) {
			return (ModeTabs)c;
		}
		throw new IllegalStateException("Unable to get mode tabs.");
	}
	
	public void setTotalValue(double total) {
		String val = String.format("%6.2f", total);
		getTotalLabel().setText(DEFAULT_TOTAL_LABEL_PREFIX_TEXT + val);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		Object src = e.getSource();
		if (src == getSaleItemDeleteButton()) {
			// TODO delete sale item ~ selected table row
		} else if (src == getStartCashPaymentButton()) {
			getModeTabs().setMode(Mode.CASH_PAYMENT);
		} else if (src == getStartCardPaymentButton()) {
			getModeTabs().setMode(Mode.CARD_PAYMENT);
		} else if (src == getCancelSaleButton()) {
		    boolean canCancel = ControllerHelper.cancelSale();
		    if (canCancel) {
		    	getModeTabs().setMode(Mode.START);
		    } else {
		    	getCancelSaleButton().setEnabled(false);
		    }
		} else if (src == getEANInput()) {
			pressOk();
		} else {
			System.err.printf("WARNING: SalePane.actionPerformed(): urecognize action source");
		}
	}
	
	private void pressOk() {
		pressOk(null);
	}
	
	private void pressOk(ActionEvent e) {
		for (ActionListener l: getOkButton().getActionListeners()) {
			System.err.printf("Ok button listener: %s.\n", l.toString());
			l.actionPerformed(e);
		}
	}
	
	public void setEANandPressOk(String EAN) {
		if (EAN != null && EAN.length() > 0) {
			getEANInput().setText(EAN);
			pressOk();			
		}
	}

	@Override
	public void selectThis(int thisIndex, int lastIndex, int subModeIndex) {
		if (thisIndex >= lastIndex) {
			// started new sale - reset all subcomponents
			setTotalValue(0);
			getSaleTableModel().deleteAllData();
			controlsSetEnabled(true);
			getCancelSaleButton().setEnabled(true);
			resetInputs();
		}
	}
}
