package org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui.swing;

import java.util.List;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.SwingWorker;

import org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui.ControllerHelper;
import org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui.SaleItemDetail;

public class SalePaneSaleAddedListener implements ActionListener {
	
	private class SaleAddedWorker extends SwingWorker<Object, SaleItemDetail> {
		private SalePane salePane;
		private String EAN;
		private double amount;
		private double total;
		private boolean success;
		
		protected SaleAddedWorker(SalePane salePane, String EAN, double amount) {
			this.salePane = salePane;
			this.EAN = EAN;
			this.amount = amount;
			this.success = false;
			this.total = 0;
		}

		@Override
		protected SaleItemDetail doInBackground() throws Exception {
			 SaleItemDetail result = ControllerHelper.itemSold(EAN, amount);
			 if (result != null) {
				 publish(result);
				 success = true;
			 }
			 total = ControllerHelper.getSum();
			 return null;
		}
		
		@Override
		protected void process(List<SaleItemDetail> rows) {
			SaleTableModel stm = salePane.getSaleTableModel();
			stm.addRows(rows);
		}
		
		@Override
		protected void done() {
			if (success) {
				//salePane.scrollSaleTableDown();
				salePane.resetInputs();
			} else {
				salePane.showValidationMessage("EAN not found.");
			}
			salePane.setTotalValue(total);
			salePane.controlsSetEnabled(true);
		}
	}
	
	private SalePane salePane;
	
	public SalePaneSaleAddedListener(SalePane context) {
		salePane = context;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		salePane.controlsSetEnabled(false);
		double amount = salePane.getCurrentAmount();
		if (amount != 0) {
			SaleAddedWorker saw = new SaleAddedWorker(salePane, salePane.getCurrentEAN(), amount);
			saw.execute();
		} else {
			salePane.showValidationMessage("Invalid amount.");
			salePane.controlsSetEnabled(true);
		}
	}

}
