package org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui.swing;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;

import org.objectweb.dsrg.sofa.demos.sofashop.cashdesk.gui.ControllerHelper;


public class StartPane extends JPanel implements ActionListener, ModePane {

	private static final long serialVersionUID = 1L;
	
	private JButton startSaleButton = null;

	/**
	 * This is the default constructor
	 */
	public StartPane() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setLayout(new GridBagLayout());
		placeStartSaleButton();
		
	}
	
	private void placeStartSaleButton() {
		GridBagConstraints startSaleButtonConstr = new GridBagConstraints();
		
		startSaleButtonConstr.gridx = 0;
		startSaleButtonConstr.gridy = 0;
		startSaleButtonConstr.ipadx = 10;
		startSaleButtonConstr.ipady = 10;
		startSaleButtonConstr.anchor = GridBagConstraints.CENTER;		
		this.add(getStartSaleButton(), startSaleButtonConstr);
	}
	
	public JButton getStartSaleButton() {
		if (startSaleButton == null) {
			startSaleButton = new JButton("Start new sale");
			startSaleButton.addActionListener(this);
			startSaleButton.setActionCommand("start sale");
		}
		return startSaleButton;
	}
	
	
	public void actionPerformed(ActionEvent e) {
		getStartSaleButton().setEnabled(false);
		ControllerHelper.saleStarted();
		Container c = getParent();
		if (c instanceof ModeTabs) {
			((ModeTabs)c).setMode(ModeTabs.Mode.SALE);
		} else {
			System.err.printf("GUI ERROR: Unable to access ModeTabs.");
		}
	}

	@Override
	public void selectThis(int thisIndex, int lastIndex, int subModeIndex) {
		getStartSaleButton().setEnabled(true);
	}

}
