	/* $Id: AbstractBase.java 649 2009-08-21 17:35:45Z ondrac $
	 *
	 * SofaShop demo for SOFA 2.0 component system
	 * Copyright (C) 2009  DSRG, Charles University in Prague
	 *                     http://dsrg.mff.cuni.cz/
	 *
	 * This library is free software; you can redistribute it and/or
	 * modify it under the terms of the GNU Lesser General Public
	 * License as published by the Free Software Foundation; either
	 * version 2.1 of the License, or (at your option) any later version.
	 *
	 * This library is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	 * Lesser General Public License for more details.
	 *
	 * You should have received a copy of the GNU Lesser General Public
	 * License along with this library; if not, write to the Free Software
	 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
	 * MA 02110-1301 USA
	 *
	 */

	package org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel;
	
	/** Base class of each database avare data model member.
	  * 
	  * <p>
	  * This class was generated from ecore model by M2T template using
	  * Acceleo MDA Generator (see http://www.acceleo.org).
	  * </p>
	  */
	public abstract class AbstractBase implements java.io.Serializable {
		/** Collection of classes defined within the model. */ 
		public static java.util.Collection<Class<?>> subClasses;
		static { /* static block which fills the collection of subclasses */
	  		subClasses =  new java.util.LinkedList<Class<?>>();
		    /* class StockItem */
		    subClasses.add(StockItem.class);
		    /* class SaleItem */
		    subClasses.add(SaleItem.class);
		    /* class Sale */
		    subClasses.add(Sale.class);
		    /* class Product */
		    subClasses.add(Product.class);
		    /* class Store */
		    subClasses.add(Store.class);
		    /* class SupplyTerms */
		    subClasses.add(SupplyTerms.class);
		    /* class Supplier */
		    subClasses.add(Supplier.class);
		    /* class ProductCategory */
		    subClasses.add(ProductCategory.class);
		    /* class OrderItem */
		    subClasses.add(OrderItem.class);
		    /* class Order */
		    subClasses.add(Order.class);
		    /* class ProductPolicy */
		    subClasses.add(ProductPolicy.class);
	 	}

		/** Identifies object as database object.
		  *
		  * The value is updated when the object is stored to database. Since then
		  * the value remains immutable.
		  */
		private static final int INVALID_INTERNAL_OBJECT_ID = -1;
		private int internal_object_ID = INVALID_INTERNAL_OBJECT_ID;
		/** <b>DO NOT USE THIS METHOD!</b> Sets internal object id.
		  * This method is intended only for internal database use.
		  */
		public static void setInternalObjectId(AbstractBase object, int id) {
			object.internal_object_ID = id;
		}
		/** Indicates whether the internal_object_ID is invalid.
		  * This method is intended only for internal database use.
		  * The internal_object_ID is valid iff the object is database aware.
		  */
		public static boolean isInternalObjectIdInvalid(AbstractBase object) {
			return (object.internal_object_ID == INVALID_INTERNAL_OBJECT_ID);
		}
		/** Helps to identify with database object ID. 
		  *
		  * @return internal object ID
		  */
		public int hashCode() {
			return internal_object_ID;
		}
		/** Makes database objects identical.
		  *
		  * @param o object to compare with
		  * @return true iff objects have same object ID
		  */
		public boolean equals(Object o) {
			if (o != null && o instanceof AbstractBase) {
				return (
					this.internal_object_ID == ((AbstractBase)o).internal_object_ID
					&&
					this.internal_object_ID != -1);
			}
			return false;
		}
	}


