	/* $Id: AbstractNeodatisODBObjectUpdater.java 763 2009-10-16 23:16:10Z ondrac $
	 *
	 * SofaShop demo for SOFA 2.0 component system
	 * Copyright (C) 2009  DSRG, Charles University in Prague
	 *                     http://dsrg.mff.cuni.cz/
	 *
	 * This library is free software; you can redistribute it and/or
	 * modify it under the terms of the GNU Lesser General Public
	 * License as published by the Free Software Foundation; either
	 * version 2.1 of the License, or (at your option) any later version.
	 *
	 * This library is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	 * Lesser General Public License for more details.
	 *
	 * You should have received a copy of the GNU Lesser General Public
	 * License along with this library; if not, write to the Free Software
	 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
	 * MA 02110-1301 USA
	 *
	 */
	 
	package org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.util.neodatisodb;

	import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.*;
	import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.util.*;	
	import org.neodatis.odb.core.query.criteria.ICriterion;	
	import org.neodatis.odb.core.query.criteria.Where;	
	
	/** This object privdes NeoDatis based object lookup.
	  *
	  * <p>
	  * This class was generated from ecore model by M2T template using
	  * Acceleo MDA Generator (see http://www.acceleo.org).
	  * </p>	  
	  *
	  */
	public abstract class AbstractNeodatisODBObjectUpdater extends AbstractObjectUpdater{
		/**	Returns local object fullfilling criterion.
		  *
		  * @param clazz class
		  * @param idCrit ID-field equality criterion
		  * @param storeReferenceFieldName for optional constraints - may be null
		  */
		protected abstract Object getReplica(Class<?> clazz, ICriterion idCrit, String storeReferenceFieldName);
			
		/**	Notifies that object released as a content of something.
		  *
		  * @param o object
		  */
		protected abstract void contentReleased(Object o);
	
		//
		// 
		//
					
		/** Creates <i>ID</i>-field equality criterion and
		  * calls getReplica()
		  *
		  * @param object
		  * @return object returned by getReplica() 
		  */
		@Override	
		protected StockItem getReplica_StockItem(StockItem object) {
			ICriterion criterion = null;
			String storeReferenceFieldName = null;
			
			criterion = Where.equal("EAN", object.getEAN());

			storeReferenceFieldName = "store";

			
			if (criterion == null) {
				throw new IllegalArgumentException("Unable to get replica of StockItem which does not have any ID field.");
			}
			
			return (StockItem) getReplica(StockItem.class, criterion, storeReferenceFieldName); 
		}
		
					
		/** Notifies that content StockItem has been released,
		  * and calls releaseContent.
		  *
		  * @param object StockItem
		  */
		@Override	
		protected void contentReleased_StockItem(StockItem object) {
			contentReleased(object);
		}
					
					
		/** Creates <i>ID</i>-field equality criterion and
		  * calls getReplica()
		  *
		  * @param object
		  * @return object returned by getReplica() 
		  */
		@Override	
		protected SaleItem getReplica_SaleItem(SaleItem object) {
			ICriterion criterion = null;
			String storeReferenceFieldName = null;
			


			
			if (criterion == null) {
				throw new IllegalArgumentException("Unable to get replica of SaleItem which does not have any ID field.");
			}
			
			return (SaleItem) getReplica(SaleItem.class, criterion, storeReferenceFieldName); 
		}
		
					
		/** Notifies that content SaleItem has been released,
		  * and calls releaseContent.
		  *
		  * @param object SaleItem
		  */
		@Override	
		protected void contentReleased_SaleItem(SaleItem object) {
			contentReleased(object);
		}
					
					
		/** Creates <i>ID</i>-field equality criterion and
		  * calls getReplica()
		  *
		  * @param object
		  * @return object returned by getReplica() 
		  */
		@Override	
		protected Sale getReplica_Sale(Sale object) {
			ICriterion criterion = null;
			String storeReferenceFieldName = null;
			

			storeReferenceFieldName = "store";

			
			if (criterion == null) {
				throw new IllegalArgumentException("Unable to get replica of Sale which does not have any ID field.");
			}
			
			return (Sale) getReplica(Sale.class, criterion, storeReferenceFieldName); 
		}
		
					
		/** Notifies that content Sale has been released,
		  * and calls releaseContent.
		  *
		  * @param object Sale
		  */
		@Override	
		protected void contentReleased_Sale(Sale object) {
			contentReleased(object);
		}
					
					
		/** Creates <i>ID</i>-field equality criterion and
		  * calls getReplica()
		  *
		  * @param object
		  * @return object returned by getReplica() 
		  */
		@Override	
		protected Product getReplica_Product(Product object) {
			ICriterion criterion = null;
			String storeReferenceFieldName = null;
			
			criterion = Where.equal("id", object.getId());


			
			if (criterion == null) {
				throw new IllegalArgumentException("Unable to get replica of Product which does not have any ID field.");
			}
			
			return (Product) getReplica(Product.class, criterion, storeReferenceFieldName); 
		}
		
					
		/** Notifies that content Product has been released,
		  * and calls releaseContent.
		  *
		  * @param object Product
		  */
		@Override	
		protected void contentReleased_Product(Product object) {
			contentReleased(object);
		}
					
					
		/** Creates <i>ID</i>-field equality criterion and
		  * calls getReplica()
		  *
		  * @param object
		  * @return object returned by getReplica() 
		  */
		@Override	
		protected Store getReplica_Store(Store object) {
			ICriterion criterion = null;
			String storeReferenceFieldName = null;
			
			criterion = Where.equal("id", object.getId());


			
			if (criterion == null) {
				throw new IllegalArgumentException("Unable to get replica of Store which does not have any ID field.");
			}
			
			return (Store) getReplica(Store.class, criterion, storeReferenceFieldName); 
		}
		
					
		/** Notifies that content Store has been released,
		  * and calls releaseContent.
		  *
		  * @param object Store
		  */
		@Override	
		protected void contentReleased_Store(Store object) {
			contentReleased(object);
		}
					
					
		/** Creates <i>ID</i>-field equality criterion and
		  * calls getReplica()
		  *
		  * @param object
		  * @return object returned by getReplica() 
		  */
		@Override	
		protected SupplyTerms getReplica_SupplyTerms(SupplyTerms object) {
			ICriterion criterion = null;
			String storeReferenceFieldName = null;
			

			storeReferenceFieldName = "store";

			
			if (criterion == null) {
				throw new IllegalArgumentException("Unable to get replica of SupplyTerms which does not have any ID field.");
			}
			
			return (SupplyTerms) getReplica(SupplyTerms.class, criterion, storeReferenceFieldName); 
		}
		
					
		/** Notifies that content SupplyTerms has been released,
		  * and calls releaseContent.
		  *
		  * @param object SupplyTerms
		  */
		@Override	
		protected void contentReleased_SupplyTerms(SupplyTerms object) {
			contentReleased(object);
		}
					
					
		/** Creates <i>ID</i>-field equality criterion and
		  * calls getReplica()
		  *
		  * @param object
		  * @return object returned by getReplica() 
		  */
		@Override	
		protected Supplier getReplica_Supplier(Supplier object) {
			ICriterion criterion = null;
			String storeReferenceFieldName = null;
			
			criterion = Where.equal("regNo", object.getRegNo());


			
			if (criterion == null) {
				throw new IllegalArgumentException("Unable to get replica of Supplier which does not have any ID field.");
			}
			
			return (Supplier) getReplica(Supplier.class, criterion, storeReferenceFieldName); 
		}
		
					
		/** Notifies that content Supplier has been released,
		  * and calls releaseContent.
		  *
		  * @param object Supplier
		  */
		@Override	
		protected void contentReleased_Supplier(Supplier object) {
			contentReleased(object);
		}
					
					
		/** Creates <i>ID</i>-field equality criterion and
		  * calls getReplica()
		  *
		  * @param object
		  * @return object returned by getReplica() 
		  */
		@Override	
		protected ProductCategory getReplica_ProductCategory(ProductCategory object) {
			ICriterion criterion = null;
			String storeReferenceFieldName = null;
			
			criterion = Where.equal("id", object.getId());


			
			if (criterion == null) {
				throw new IllegalArgumentException("Unable to get replica of ProductCategory which does not have any ID field.");
			}
			
			return (ProductCategory) getReplica(ProductCategory.class, criterion, storeReferenceFieldName); 
		}
		
					
		/** Notifies that content ProductCategory has been released,
		  * and calls releaseContent.
		  *
		  * @param object ProductCategory
		  */
		@Override	
		protected void contentReleased_ProductCategory(ProductCategory object) {
			contentReleased(object);
		}
					
					
		/** Creates <i>ID</i>-field equality criterion and
		  * calls getReplica()
		  *
		  * @param object
		  * @return object returned by getReplica() 
		  */
		@Override	
		protected OrderItem getReplica_OrderItem(OrderItem object) {
			ICriterion criterion = null;
			String storeReferenceFieldName = null;
			


			
			if (criterion == null) {
				throw new IllegalArgumentException("Unable to get replica of OrderItem which does not have any ID field.");
			}
			
			return (OrderItem) getReplica(OrderItem.class, criterion, storeReferenceFieldName); 
		}
		
					
		/** Notifies that content OrderItem has been released,
		  * and calls releaseContent.
		  *
		  * @param object OrderItem
		  */
		@Override	
		protected void contentReleased_OrderItem(OrderItem object) {
			contentReleased(object);
		}
					
					
		/** Creates <i>ID</i>-field equality criterion and
		  * calls getReplica()
		  *
		  * @param object
		  * @return object returned by getReplica() 
		  */
		@Override	
		protected Order getReplica_Order(Order object) {
			ICriterion criterion = null;
			String storeReferenceFieldName = null;
			
			criterion = Where.equal("code", object.getCode());

			storeReferenceFieldName = "store";

			
			if (criterion == null) {
				throw new IllegalArgumentException("Unable to get replica of Order which does not have any ID field.");
			}
			
			return (Order) getReplica(Order.class, criterion, storeReferenceFieldName); 
		}
		
					
		/** Notifies that content Order has been released,
		  * and calls releaseContent.
		  *
		  * @param object Order
		  */
		@Override	
		protected void contentReleased_Order(Order object) {
			contentReleased(object);
		}
					
					
		/** Creates <i>ID</i>-field equality criterion and
		  * calls getReplica()
		  *
		  * @param object
		  * @return object returned by getReplica() 
		  */
		@Override	
		protected ProductPolicy getReplica_ProductPolicy(ProductPolicy object) {
			ICriterion criterion = null;
			String storeReferenceFieldName = null;
			

			storeReferenceFieldName = "store";

			
			if (criterion == null) {
				throw new IllegalArgumentException("Unable to get replica of ProductPolicy which does not have any ID field.");
			}
			
			return (ProductPolicy) getReplica(ProductPolicy.class, criterion, storeReferenceFieldName); 
		}
		
					
		/** Notifies that content ProductPolicy has been released,
		  * and calls releaseContent.
		  *
		  * @param object ProductPolicy
		  */
		@Override	
		protected void contentReleased_ProductPolicy(ProductPolicy object) {
			contentReleased(object);
		}
					
		
	}

