/* $Id: ISelect.java 652 2009-08-24 00:17:16Z ondrac $
 *
 * SofaShop demo for SOFA 2.0 component system
 * Copyright (C) 2009  DSRG, Charles University in Prague
 *                     http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.objectweb.dsrg.sofa.demos.sofashop.db;

import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.AbstractBase;
import org.neodatis.odb.core.query.IQuery;
import org.neodatis.odb.Objects;

public interface ISelect {
  /** Fetches objects matching query <code>q</code> from database.
    *
    * @param q query
    * @return objects matching query
    * @throws DatabaseUnreachableException database is unreachable
    * @throws InvalidContextException call context has not been initialized yet
    *   (retry is suggested)
    */
  public <T extends AbstractBase> Objects<T> select(IQuery q)
    throws DatabaseUnreachableException, InvalidContextException;

  /** Fetches sublist of objects matching query <code>q</code> from database.
    *
    * @param q query
    * @param startIndex index of the first returned object
    * @param endIndex index of the first object behind the last returned object
    * @return sublist of objects matching query
    * @throws DatabaseUnreachableException database is unreachable
    * @throws InvalidContextException call context has not been initialized yet
    *   (retry is suggested)
    */
  public <T extends AbstractBase> Objects<T> select(IQuery q, int startIndex, int endIndex)
    throws DatabaseUnreachableException, InvalidContextException;

}
