/* $Id: InvalidContextException.java 644 2009-08-19 16:07:34Z ondrac $
 *
 * SofaShop demo for SOFA 2.0 component system
 * Copyright (C) 2009  DSRG, Charles University in Prague
 *                     http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.objectweb.dsrg.sofa.demos.sofashop.db;

import java.io.Serializable;

/** Thrown when an action of a transaction has been invoked from invalid
  * context.
  *
  * <p>This exception may occur when a call occured before SOFAThreadHelper
  * initialized its context. Since this error is recoverable (SOFAThreadHelper
  * should initialize itself once), it might be handled as transaction ABORT
  * and a retry is possible.</p>
  * 
  */
public class InvalidContextException 
extends TransactionAbortedException implements Serializable {
  public InvalidContextException() {
    super();
  }
  public InvalidContextException(String msg) {
    super(msg);
  }
  public InvalidContextException(Throwable t) {
    super(t);
  }
  public InvalidContextException(String msg, Throwable t) {
    super(msg, t);
  }
}

