/* $Id: QueryResultImpl.java 644 2009-08-19 16:07:34Z ondrac $
 *
 * SofaShop demo for SOFA 2.0 component system
 * Copyright (C) 2009  DSRG, Charles University in Prague
 *                     http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.objectweb.dsrg.sofa.demos.sofashop.db.storage;

import java.util.Set;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.AbstractBase;
import org.neodatis.odb.OID;
import org.neodatis.odb.Objects;

/** Represents result of database query.
  *
  * @author Ondrej Cerny 
  */
public class QueryResultImpl <T extends AbstractBase> implements QueryResult<T> {
  /** Set of OIDs. */
  private Set<OID> oidSet;
  /** Collection of objects. */
  private Objects<T> objectCollection;
  /** Non parametric constructor for RMI.
    */
  public QueryResultImpl() {
    oidSet = null;
    objectCollection = null;
  }
  /** Creates query result containing objects and oids.
    *
    * @param objects objects
    * @param oid OIDs
    */
  public QueryResultImpl(Objects<T> objects, Set<OID> oids) {
    oidSet = oids;
    objectCollection = objects;
  }
  /** Retursn collection of fetched objects.
    * 
    * @return objects
    */
  public Objects<T> getObjects() {
    return objectCollection;
  }
  /** Returns set of OIDs of newly fetched objects.
    *
    * @return OIDs
    */
  public Set<OID> getObjectIds() {
    return oidSet;
  }
}
