/* $Id: Credentials.java 763 2009-10-16 23:16:10Z ondrac $
 *
 * SofaShop demo for SOFA 2.0 component system
 * Copyright (C) 2009  DSRG, Charles University in Prague
 *                     http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.objectweb.dsrg.sofa.demos.sofashop.de;

import java.io.Serializable;

import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.Store;

/**
  * @author Ondrej Cerny
  *
  */
public class Credentials implements Serializable {
	
	private static final long serialVersionUID = -2836569644103980624L;
	private final Store store;
	private final String passphrase;

	/** Initiates credentials.
	  * 
	  * @param store store
	  * @param passphrase passphrase
	  */
	public Credentials(Store store, String passphrase) {
		this.store = new Store();
		this.store.setId(store.getId());		
		this.passphrase = passphrase;
	}
	
	/** Returns store.
	  * 
	  * @return store
	  */
	public Store getStore() {
		return store;
	}
	/** Returns passphrase
	  * 
	  * @return passphrase
	  */
	public String getPassphrase() {
		return passphrase;
	}

}
