/* $Id: DataExchangeUploadHelper.java 766 2009-10-17 23:52:31Z ondrac $
 *
 * SofaShop demo for SOFA 2.0 component system
 * Copyright (C) 2009  DSRG, Charles University in Prague
 *                     http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.objectweb.dsrg.sofa.demos.sofashop.de;

import java.util.List;

import org.apache.log4j.Logger;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.AbstractBase;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.Store;
import org.objectweb.dsrg.sofa.demos.sofashop.db.DatabaseUnreachableException;
import org.objectweb.dsrg.sofa.demos.sofashop.db.ITransact;

/**
 * @author Ondrej Cerny
 *
 */
public class DataExchangeUploadHelper {
	private static Logger logger = Logger.getLogger(DataExchangeUploadHelper.class);
	
	/** Uploads objects (updates local replicas).
	  * 
	  * @param <O>
	  * @param database
	  * @param store
	  * @param ojects
	  * @throws DatabaseUnreachableException
	  * @throws DataExchangeRefusedException when the object type is not supported
	  */
	public static <O extends AbstractBase> void uploadObjects(ITransact database, Store store, List<O> ojects)
		throws DatabaseUnreachableException,
		       DataExchangeRefusedException {
		if (database == null) {
			logger.trace("Bad param: database is null.");
			throw new DatabaseUnreachableException(
					"Database provider has not been initialized properly.");
		}
		if (store == null) {
			logger.trace("Bas param: store is null.");
			throw new DataExchangeRefusedException(
					"Unable to bind objects to null store.");
		}
		throw new DataExchangeRefusedException(
				"Object upload not impelemented yet.");
	}

}
