/* $Id: DataExchangeWorker.java 763 2009-10-16 23:16:10Z ondrac $
 *
 * SofaShop demo for SOFA 2.0 component system
 * Copyright (C) 2009  DSRG, Charles University in Prague
 *                     http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.objectweb.dsrg.sofa.demos.sofashop.de;

import org.apache.log4j.Logger;
import org.neodatis.odb.core.query.criteria.ICriterion;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.AbstractBase;

public class DataExchangeWorker implements Runnable {
	private static Logger logger = Logger.getLogger(DataExchangeWorker.class);
	private DataExchangeAction action;
	private Class<? extends AbstractBase> clazz;
	private ICriterion criteria;
	private DataExchangeActionContainer actionContainer;
	private Exception processException = null;
	
	public DataExchangeWorker(DataExchangeActionContainer actionContainer, 
			DataExchangeAction action,
			Class<? extends AbstractBase> clazz,
			ICriterion cirteria) {
		this.action = action;
		this.clazz = clazz;
		this.criteria = cirteria;
		this.actionContainer = actionContainer;
	} 
	@Override
	public void run() {
		try {
			this.action.perform(this.clazz, this.criteria);
		} catch (Exception e) {
			processException = e;
			logger.error("Error during data exchange: ", e);
			logger.trace("Ignoring previous error.");
		}
		
		actionContainer.putAction(action);
	}
	
}
