/* $Id: OrderInconsistentException.java 762 2009-10-12 11:19:00Z ondrac $
 *
 * SofaShop demo for SOFA 2.0 component system
 * Copyright (C) 2009  DSRG, Charles University in Prague
 *                     http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */
package org.objectweb.dsrg.sofa.demos.sofashop.inv.order;

import org.objectweb.dsrg.sofa.demos.sofashop.inv.InventoryUnreachableException;

/**
 * @author Ondrej Cerny
 *
 */
public class OrderInconsistentException extends InventoryUnreachableException {

	/** Generated serial version ID. */
	private static final long serialVersionUID = 5303563586893261163L;

	/** Creates new instance with message and cause.
	  * 
	  * @param message
	  * @param t
	  */
	public OrderInconsistentException(String message, Throwable t) {
		super(message, t);
	}

	/** Creates new instance with message.
	  * 
	  * @param message
	  */	
	public OrderInconsistentException(String message) {
		super(message);
	}
	
	/** Creates new instance with default message.
	  * 
	  */
	public OrderInconsistentException() {
		super("Order inconsistent.");
	}

}
