/* $Id: DefaultTextReportPrint.java 770 2009-10-19 10:30:55Z ondrac $
 *
 * SofaShop demo for SOFA 2.0 component system
 * Copyright (C) 2009  DSRG, Charles University in Prague
 *                     http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.objectweb.dsrg.sofa.demos.sofashop.rep.common;

/**
 * @author Ondrej Cerny
 *
 */
public class DefaultTextReportPrint implements TextReportPrint {
	
	private final String text;
	private final String textType;
	
	public DefaultTextReportPrint(String textType, String text) {
		this.text = text;
		this.textType = textType;
	}

	/**
	 * @see org.objectweb.dsrg.sofa.demos.sofashop.rep.common.TextReportPrint#getTextType()
	 */
	@Override
	public String getTextType() {
		return textType;
	}

	/**
	 * @see org.objectweb.dsrg.sofa.demos.sofashop.rep.common.TextReportPrint#render()
	 */
	@Override
	public String render() {
		return text;
	}

}
