/* $Id: Test.java 770 2009-10-19 10:30:55Z ondrac $
 *
 * SofaShop demo for SOFA 2.0 component system
 * Copyright (C) 2009  DSRG, Charles University in Prague
 *                     http://dsrg.mff.cuni.cz/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA
 *
 */

package org.objectweb.dsrg.sofa.demos.sofashop.rep.common.util;

import java.util.LinkedList;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;

import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.PatternLayout;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.Report;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.ReportDataProvider;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.ReportParameter;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.ReportParameterImpl;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.ReportParameterLabeledValue;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.ReportPrint;

/**
 * @author Ondrej Cerny
 *
 */
public class Test implements Runnable {
	
	public class FooReport implements Report {
		
		public FooReport() {
		}
		
		private List<ReportParameter> getParams() {
			List<ReportParameter> params = new LinkedList<ReportParameter>();			
			params.add(new ReportParameterImpl ("jedna", "hello", String.class, false,
					new ReportParameterLabeledValue("re", "re")));
			params.add(new ReportParameterImpl ("dva", "world", String.class, false,
					new ReportParameterLabeledValue("re", "re")));
			
			ReportParameterImpl combo = new ReportParameterImpl(
					"tri", "yep", String.class, false, null);
			
			LinkedList<ReportParameterLabeledValue> list = new LinkedList<ReportParameterLabeledValue>();
			list.add(new ReportParameterLabeledValue("a", "a"));					
			list.add(new ReportParameterLabeledValue("b", "b"));					
			list.add(new ReportParameterLabeledValue("c", "c"));					
					
			combo.setAvailableValues(list);
			
			params.add(combo);
			
			return params;
		}
		@Override
		public List<ReportParameter> getParameters() {
			return getParams();
		}
		@Override
		public List<ReportParameter> getParameters(
				List<ReportParameter> currentValues) {
			return getParams();
		}
		@Override
		public ReportPrint getPrint(List<ReportParameter> values)
				throws IllegalArgumentException {
			return null;
		}

		@Override
		public void setDataProvider(ReportDataProvider p) {
		}		
	}
	
	/** Configures Log4j if it has not been configured yet.
	  * 
	  */
	public static void configureLog4j() {
		Logger root = Logger.getRootLogger();
		if (root != null && !root.getAllAppenders().hasMoreElements()) {
			// not null and no appenders => not configured yet
			root.setLevel(Level.ALL);
			root.addAppender(new ConsoleAppender(
					new PatternLayout(PatternLayout.TTCC_CONVERSION_PATTERN)));
			//logger.warn("Log4j configured.");
		} else {
			System.err.printf("Log4j already configured or null root logger.");
		}
	}


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		configureLog4j();
		SwingUtilities.invokeLater(new Test());
	}

	@Override
	public void run() {
		ReportParameterIntputContainerPane ricp = new ReportParameterIntputContainerPane();
		ricp.setReport(new FooReport());
		JFrame f = new JFrame("Test");
		f.setSize(300, 300);
		f.add(ricp);
		f.setVisible(true);
	}
}
