package org.objectweb.dsrg.sofa.demos.sofashop.store.client;

import java.util.List;
import java.util.Set;

import org.apache.log4j.Logger;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.IReporting;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.InvalidReportParameterException;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.ReportDataProcessingException;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.ReportParameter;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.ReportPrint;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.service.AbstractReportingServiceClient;
import org.objectweb.dsrg.sofa.demos.sofashop.rep.common.service.ReportingService;

public class ReportingServiceClient extends AbstractReportingServiceClient implements ReportingService {
	
	private static Logger logger = Logger.getLogger(ReportingServiceClient.class);
	
	private IReporting iprovider;
	
	public ReportingServiceClient(IReporting provider) {
		logger.trace("creating reporting service provider");
		this.iprovider = provider;
	}

	@Override
	protected ReportingService getSerivceProvider() {
		logger.trace("call");
		return this;
	}

	@Override
	public void closeReport(int id) {
		logger.trace("call");
		iprovider.closeReport(id);
		
	}

	@Override
	public List<ReportParameter> getReportParameters(int id) throws ReportDataProcessingException {
		logger.trace("call");
		return iprovider.getReportParameters(id);
	}

	@Override
	public List<ReportParameter> getReportParameters(int id,
			List<ReportParameter> currentValues) throws ReportDataProcessingException {
		logger.trace("call");
		return iprovider.getReportParameters(id, currentValues);
	}

	@Override
	public ReportPrint getReportPrint(int id, List<ReportParameter> values)
	throws ReportDataProcessingException, InvalidReportParameterException {
		logger.trace("call");
		return iprovider.getReportPrint(id, values);
	}

	@Override
	public int openReport(String reportName) {
		logger.trace("call");
		return iprovider.openReport(reportName);
	}
	
	@Override
	public Set<String> getReportNames() {
		logger.trace("getReportNames - call");
		return iprovider.getReportNames();
	}
}
