package org.objectweb.dsrg.sofa.demos.sofashop.store.client;

import javax.swing.JFrame;
import javax.swing.UIManager;

import org.apache.log4j.Logger;
import org.objectweb.dsrg.sofa.demos.sofashop.store.client.gui.MainTabbedPane;


public class SwingInitializer implements Runnable {
	private static Logger logger = Logger.getLogger(SwingInitializer.class);
	
	private static final String LOOKNFEEL = "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel";
	
	private MainTabbedPane mainTabbedPane = null;
	private JFrame mainFrame = null;
	
	public SwingInitializer() {
		logger.trace("Trying to set look and feel.");
		try {
			UIManager.setLookAndFeel(LOOKNFEEL);
		} catch (Throwable t) {
			logger.warn(
				"Unable to set look and feel " + LOOKNFEEL + ".");
		}		
	}
	/** Starts or stops GUI.
	  * 
	  * <p>Odd (1st, 3rd, ...) executions start GUI.</p>
	  * <p>Even (2nd, 4th, ...) executions stop GUI.</p>
	  */
	public void run() {
		if (mainFrame == null) {
			logger.trace("Starting GUI");
			mainTabbedPane = new MainTabbedPane();
			logger.trace("main tabbed pane initialized");
			mainFrame = new JFrame("Store Client");
			mainFrame.setSize(700,700);		
			mainFrame.setContentPane(mainTabbedPane);
			mainFrame.setVisible(true);
			logger.trace("GUI started.");
		} else {
			logger.trace("Stopping GUI.");			
			mainFrame.dispose();
			mainFrame = null;
		}
	}
}
