package org.objectweb.dsrg.sofa.demos.sofashop.store.client.debug;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.Product;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.Supplier;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.SupplyTerms;
import org.objectweb.dsrg.sofa.demos.sofashop.store.client.gui.MainTabbedPane;
import org.objectweb.dsrg.sofa.demos.sofashop.store.client.gui.order.OrderItemDialog;

public class TestWindow extends JFrame implements ActionListener {

	private static final long serialVersionUID = 1L;

	private MainTabbedPane mainTPane = null;
	private JPanel mainPane = null;
	private JLabel productIdInputLabel = null;
	private JTextField productIdInput = null;
	private JButton productIdInputButton = null;
	
	private OrderItemDialog oid = null;

	/**
	 * This is the default constructor
	 */
	public TestWindow() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setContentPane(getMainTPane());
		this.setTitle("Cash desk");
		this.setSize(700,700);
	}

	public JPanel getMainPane() {
		if (mainPane == null) {
			mainPane = new JPanel();
			mainPane.add(getProductIdInputLabel());
			mainPane.add(getProductIdInput());
			mainPane.add(getProductIdInputButton());
		}
		return mainPane;
	}
	public MainTabbedPane getMainTPane() {
		if (mainTPane == null) {
			mainTPane = new MainTabbedPane();
		}
		return mainTPane;
	}

	public JLabel getProductIdInputLabel() {
		if (productIdInputLabel == null) {
			productIdInputLabel = new JLabel("Test new order item dialog:");
		}
		return productIdInputLabel;
	}

	public JTextField getProductIdInput() {
		if (productIdInput == null) {
			productIdInput = new JTextField();
			productIdInput.setText("--product id--");
		}
		return productIdInput;
	}
	
	public JButton getProductIdInputButton() {
		if (productIdInputButton == null) {
			productIdInputButton = new JButton("Test");
			productIdInputButton.addActionListener(this);
		}
		return productIdInputButton;
	}
		
	public long getProductId() {
		long result = 0;
		String val = getProductIdInput().getText();
		if (val != null) {
			try {
				result = Long.valueOf(val).longValue();
			} catch (Throwable t) {
				System.out.printf("Warning: Illegal value (~%s) of product id input.\n", val == null ? "null" : "'" + val + "'");
				result = 0;
			}
		}
		return result; 
	}
	
	public OrderItemDialog showOrderItemDialog(Product p) {
		oid = new OrderItemDialog(this, p);
		oid.setVisible(true);
		return oid;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == getProductIdInputButton()) {
			// test order item dialog 
			long id = getProductId();
			int intId = 0;
			if (id >= 0 && id < 4096) {
				intId = (int) id;
			}
			System.out.printf("Info: Testing order item dialog (product id = %d).\n", intId);
						
			showOrderItemDialog(TestingProductsDataSource.getProduct(intId));
			
		}
	}
	
	
}
