package org.objectweb.dsrg.sofa.demos.sofashop.store.client.debug;

import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.Product;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.StockItem;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.Supplier;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.SupplyTerms;

public class TestingProductsDataSource {
	// +--------------------------------------------------------+
	//  Testing product
	// +--------------------------------------------------------+
	
	private static Supplier[] suppliers = {null, null};
	private static Product[] products = {null, null, null, null};
	
	public static Collection<StockItem> getProductStockItems() {
		LinkedList<StockItem> l = new LinkedList<StockItem>();
		for (int i = 0; i < products.length; ++i) {
			Product p = products[i];
			if (p == null) {
				p = createTestProduct(i);
				products[i] = p;
			}
			
			StockItem si = new StockItem();
			si.setEAN(p.getDefaultEAN());
			si.setAmount(i * 13);
			si.setPrice(p.getDefaultPrice());
			si.setProduct(p);
			l.add(si);
		}
		return l;
	}
	
	public static Product getProduct(int number) {
		Product p = null;
		if (number >= 0 && number < products.length) {
			p = products[number];
			if (p == null) {
				p = createTestProduct(number);
				products[number] = p;
			}
		} else if (number >= 0) {
			p = createTestProduct(number);
		}
		return p;
	}
	
	private static Supplier getSupplier(int ix) {
		Supplier s = null; 
		if (ix >= 0 && ix < suppliers.length) {
			s = suppliers[ix];
			if (s == null) {
				switch (ix) {
				case 0:
					s = new Supplier();
					s.setName("Pavel Masek");
					s.setRegNo("23345113");
					break;
				case 1:
					s = new Supplier();
					s.setName("Marketa Hrubesova");
					s.setRegNo("24561399");
					
				default: break;
				}
			}
			suppliers[ix] = s;
		}
		return s;
	}
	
	private static Product createTestProduct(int number) {
		number++;
		Product p = new Product();
		p.setDefaultEAN(Integer.toOctalString((3334 * number) % 512));
		p.setDefaultPrice(3.5 * number);
		p.setDescription("The very new news (" + Integer.toString(number)+ ").");
		p.setName("Newspaper" + Integer.toString(number));
		p.setId(number);
		List<SupplyTerms> sterms = new LinkedList<SupplyTerms>();
		
		Supplier s;
		SupplyTerms st;
		
		s = getSupplier(0);
		
		st = new SupplyTerms();
		st.setLowerLimitIncl(0);
		st.setUpperLimitExcl(50);
		st.setPrice(2 * number);
		st.setSupplier(s);
		sterms.add(st);
		
		st = new SupplyTerms();
		st.setLowerLimitIncl(50);
		st.setUpperLimitExcl(100);
		st.setPrice(1.9 * number);
		st.setSupplier(s);
		sterms.add(st);
		
		st = new SupplyTerms();
		st.setLowerLimitIncl(100);
		st.setUpperLimitExcl(-1);
		st.setPrice(1.75 * number);
		st.setSupplier(s);
		sterms.add(st);
		
		s = getSupplier(1);
		
		st = new SupplyTerms();
		st.setLowerLimitIncl(0);
		st.setUpperLimitExcl(200);
		st.setPrice(1.95 * number);
		st.setSupplier(s);
		sterms.add(st);
		p.setSupplyTerms(sterms);		

		st = new SupplyTerms();
		st.setLowerLimitIncl(200);
		st.setUpperLimitExcl(-1);
		st.setPrice(1.7 * number);
		st.setSupplier(s);
		sterms.add(st);
		p.setSupplyTerms(sterms);		

		return p;
	}


	
}
