package org.objectweb.dsrg.sofa.demos.sofashop.store.client.gui.order;


import javax.swing.tree.DefaultMutableTreeNode;

import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.Order;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.OrderItem;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.Product;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.Supplier;
import org.objectweb.dsrg.sofa.demos.sofashop.common.datamodel.SupplyTerms;

public class OrderTreeNode extends DefaultMutableTreeNode {
	private Order order;
	private OrderItem orderItem;
	protected OrderTreeNode(Order o, OrderItem oi) {
		super();
		order = o;		
		orderItem = oi;
		if (o != null) {
			setUserObject(o);
		} else if (oi != null) {
			setUserObject(oi);
		}
	}
	public OrderTreeNode(OrderItem oi) {
		this(null, oi);
	}	
	public OrderTreeNode(Order o) {
		this(o, null);
	}
	public OrderTreeNode() {
		this(null, null);
	}
	
	public Order getOrder() {
		return order;
	}
	public OrderItem getOrderItem() {
		return orderItem;
	}
	public boolean isOrder() {
		return (order != null);
	}
	public boolean isOrderItem() {
		return (orderItem != null);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		if (order != null) {
			Supplier s = order.getSupplier();
			sb.append("Supplier Reg. No.: ");
			sb.append(String.format("%10s", s.getRegNo()));
			sb.append("    Name: ");
			sb.append(s.getName());
		} else if (orderItem != null) {
			SupplyTerms st = orderItem.getTerms();
			Product p = orderItem.getProduct();
			sb.append("Product Id: ");
			sb.append(String.format("%5d", p.getId()));
			sb.append("     Name: ");
			sb.append(String.format("%10s", p.getName()));			
			sb.append("     Amount: ");
			sb.append(String.format("%6.2f", orderItem.getAmount()));
			sb.append("     Unit Price: ");
			sb.append(String.format("%6.2f", st.getPrice()));
			sb.append("     Total: ");
			sb.append(String.format("%6.2f", st.getPrice() * orderItem.getAmount()));
		}
		return sb.toString();
	}
}
